// dbll.h
#ifndef _DBLL_H_
#define _DBLL_H_

// abstract data type used for
// the double linked list library
typedef struct dbll{
	char dummy[1];
}*DBLL;

DBLL   dbll_append( DBLL node, void * data );         // append to list
int    dbll_count( DBLL root );                       // get count
void   dbll_delete_all( DBLL root );                  // delete all nodes
void   dbll_delete_node( DBLL node );                 // delete one node
int    dbll_findindex( DBLL root, const void * data );// index in list from data
DBLL   dbll_findnode( DBLL root, const void * data ); // find node from data
void * dbll_getdata( DBLL node );                     // get data from node
DBLL   dbll_getfirst( DBLL root );                    // get first real node
int    dbll_getindex( DBLL node );                    // get index of node
DBLL   dbll_getlast( DBLL node );                     // get last node
DBLL   dbll_getnext( DBLL node );                     // get next node
DBLL   dbll_getnode( DBLL node, int index );          // get node from index
DBLL   dbll_getprev( DBLL node );                     // get previous node
DBLL   dbll_insert( DBLL node, void * data, int index );// insert at index
DBLL   dbll_insert_sorted( DBLL node, void * data, int (*comp)(const void *, const void *) );
DBLL   dbll_msort( DBLL root, int (*comp)(const void *, const void *) );
DBLL   dbll_new( void );                              // create new list
DBLL   dbll_prepend( DBLL node, void * data );        // prepend
void   dbll_libvers();

#endif
