//  dirent.h
//
//    Definitions for POSIX directory operations.
//
//
//      C Run Time Library - Version 1.0
//
//      Copyright (c) 2001 by John Findlay
//      All Rights Reserved.
//

#ifndef __DIRENT_H
#define __DIRENT_H

#include <windows.h>  /* For WIN32_FIND_DATA */

#ifdef __cplusplus
extern "C" {
#endif

#pragma pack(push,1)

void dirent_libvers();

// DIR struct, opendir() returns a pointer to this.
// The members of this structure must not be
// accessed by application programs.
typedef struct tagDIR{
	int				d_cnt;					// how many reads
	HANDLE			d_hdir;					// directory handle
	char		 	   *d_dirname;				// directory name
	unsigned int	d_magic;					// magic cookie for verifying handle
	WIN32_FIND_DATA d_fd;					// buffer for a single file
} DIR;

// DIRENT struct returned by readdir()
typedef struct tagDIRENT{
	char			 *d_name;						// file name
	unsigned int d_attrib;						// file attribute
	long long    d_size;							// file size (note: long long)
	FILETIME 	 d_ftCreationTime;			//
	FILETIME 	 d_ftLastAccessTime;			//
	FILETIME 	 d_ftLastWriteTime;			//
}DIRENT;

// Prototypes
DIR     *opendir(const char *dirname);
DIRENT  *readdir(DIR *dir);
int     closedir(DIR *dir);
void    rewinddir(DIR *dir);

#ifdef __cplusplus
}
#endif

#pragma pack(pop)

#endif  // __DIRENT_H



