//*************************************************************
//
// dirtest.c
//
// Johh at <John.Findlay1@btinternet.com>
//
// You must have the LCC-Win32 distribution of 27th Nov 2001
// or later for using the jlib library.
//
//*************************************************************

#include <windows.h>
#include <stdio.h>
#include "dirent.h"   // for dir functions. Link with jlib.lib

//
// The search string takes the same from as when using the
// windows FindFirstFile() for this example I've used "c:\\*.*"
//

void PrintName(unsigned int attrib, char *szName, long long llsize);

int main(void)
{
	DIR 	*dir;
	DIRENT  *ent;
	char dirname[] = "c:\\*.*";

	printf("First pass on '%s':\n\n", dirname);

	dir = opendir(dirname);
	if ((dir == INVALID_HANDLE_VALUE) || (dir == 0)){
		printf("Unable to open directory");
		return 0;
	}

	while ((ent = readdir(dir)) != NULL){
		sleep(20);
		printf("%d", dir->d_cnt);
		PrintName(ent->d_attrib, ent->d_name, ent->d_size);
	}

	rewinddir(dir);

	printf("\n");
	printf("Second pass on '%s':\n\n", dirname);
	sleep(2000);
	while ((ent = readdir(dir)) != NULL){
		sleep(20);
		PrintName(ent->d_attrib, ent->d_name, ent->d_size);
	}

	if (closedir(dir) != 0){
		printf("Unable to close directory");
	}
//	dirent_libvers();
	printf("\nPress <Enter>\n");
	fgets(dirname, 8, stdin);

	return 0;
}

void PrintName(unsigned int attrib, char *szName, long long llsize)
{
	char szAttrib[20];
	char szSize[20];

	if (attrib & FILE_ATTRIBUTE_DIRECTORY)
		lstrcpy(szAttrib, TEXT("<DIR>"));
	else
		lstrcpy(szAttrib, TEXT(""));

	_ui64toa(llsize, szSize, 10);

	printf("%s\t%s\t%s\t\n", szAttrib, szSize, szName);
}

/*
FILE_ATTRIBUTE_ARCHIVE:
FILE_ATTRIBUTE_COMPRESSED:
FILE_ATTRIBUTE_DIRECTORY:
FILE_ATTRIBUTE_ENCRYPTED:
FILE_ATTRIBUTE_HIDDEN:
FILE_ATTRIBUTE_NORMAL:
FILE_ATTRIBUTE_OFFLINE:
FILE_ATTRIBUTE_READONLY:
FILE_ATTRIBUTE_REPARSE_POINT
FILE_ATTRIBUTE_SPARSE_FILE
FILE_ATTRIBUTE_SYSTEM
FILE_ATTRIBUTE_TEMPORARY
*/


