// test_tmalloc.c
#include <stdlib.h>  // for malloc and friends when not using "tmalloc.h"
#include "tmalloc.h" // tmalloc should be included after stdlib.h
#include "tcheck.h"
//
// make project with 'test_tmalloc.c' and 'tcheck.c'
//
//------------------------------------------
// Including tmalloc.h redefines malloc etc.
//
//  malloc()  -> tmalloc()
//  calloc()  -> tcalloc()
//  realloc() -> trealloc()
//  free()    -> tfree()
//
// When testing is finished do not include
// tmalloc.h, then all functions will be
// normal again.
//-------------------------------------------

int main( void )
{
	char * a = malloc( 1000 );
	char * b = calloc( 1, 2000 );
	char * c = malloc( 1000 );

#ifdef _TMALLOC_
	report_heap();
#endif

	foo(); // malloc in another translation unit, tcheck.c

	b = realloc( b, 3000 );

#ifdef _TMALLOC_
	report_heap();
#endif

	free( a );
	realloc( b, 0 );					// free
	free( c );

	char * d = realloc( NULL, 3000 ); 	// ordinary malloc
	free(d);

#ifdef _TMALLOC_
	report_heap();
#endif

    return 0;
}

